# benchmarking app

This is the web application to test the simplification libraries on different devices. It is implemented as a npm project. To build the project and run the developent server `npm` and `nodejs` are required.

- Install dependencies: `npm install`
- Run the development server: `npm run serve`
- Build the app: `npm run build`

## Structure

Important files:

- `.babelrc`: Configuration of the transpiler "babel"
- `.prettierrc`: Configuration of the code formatter "Prettier"
- `package.json`: Listing project information, scripts and dependencies
- `webpack.config.js` Configuration of the asset bundler "webpack"

Important folders:

- `public`: Static files. Entrypoints for pages. Stylesheets
- `results`: The prepared results in json format. The index.js gathers all for importing them in JavaScript.
- `src`: JavaScript source files

## Structure of the JavaScript source files

There are three entry points for the three web pages built:

- `index.js`: The main app for benchmarking.
- `loadChart.js`: Loading a previously saved chart file to display the interactive chart.
- `results.js`: Interactive overview for the prepared results

`loadChart.js` and `results.js` are mostly self-contained or only require external dependencies. Via `index.js` the other JavaScript files are imported.

Folders in the `src` folder:

- `benchmarkCases`: Implementation of the several cases that are benchmarked
- `benchmarks`: The three benchmark types and the benchmark suite.
- `components`: The React UI-components
- `data`: The three data sets.
