import { Case } from './Case.js'

import simplifyJSAlt from '../../../lib/simplify-js-alternative/simplify.js'
import simplifyJS from '../../../lib/turf-simplify/lib/simplify.js'

function arrayToObjectFormat(coords) {
  return coords.map(coord => {
    return { x: coord[0], y: coord[1] }
  })
}

export class SimplifyJSAltCase extends Case {
  get name() {
    return 'simplifyJSAlt'
  }
  async fn() {
    const { data, tol, highQuality } = this.parameters
    simplifyJSAlt(data, tol, highQuality)
  }
}

export class SimplifyJSCase extends Case {
  get name() {
    return 'simplifyJS'
  }
  async setup() {
    this.parameters.dataObjectForm = arrayToObjectFormat(this.parameters.data)
  }
  async fn() {
    const { dataObjectForm, tol, highQuality } = this.parameters
    simplifyJS(dataObjectForm, tol, highQuality)
  }
}
