import { BenchmarkType } from './Benchmark.js'

export class IterationsBenchmark extends BenchmarkType {
  constructor(iterations) {
    super()
    this.iterations = iterations
  }

  async measure() {
    let start = performance.now()
    for (let i = 0; i < this.iterations; i++) {
      await this.case.fn()
    }
    let stop = performance.now()
    return (stop - start) / this.iterations
  }
}
